// Ionic Starter App

var appVersion = '0.0.0';

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter.services', [])
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'starter.directives'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if('cordova' in window && 'plugins' in window.cordova && 'Keyboard' in window.cordova.plugins) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
    try {
      cordova.getAppVersion(function(version) {
        appVersion = version;
        console.log('Version ' + appVersion);
      });
    }
    catch(err) {
      console.log('Could not load app version');
    }
  });
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

  // position the tabs on the bottom (Android puts them at the top).
  $ionicConfigProvider.tabs
    .position('bottom');

  // hide text from back button
  $ionicConfigProvider.backButton
    .text('  ')
    .previousTitleText(false)
    ;

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

    // setup an abstract state for the tabs directive
    .state('tab', {
      url: "/tab",
      abstract: true,
      templateUrl: "templates/tabs.html",
      controller: 'TabsCtrl as tabsCtrl',
    })

    .state('tab.reports', {
      url: '/reports',
      views: {
        'tab-reports': {
          templateUrl: 'templates/tab-reports.html',
          controller: 'ReportsCtrl as reportsCtrl',
        }
      }
    })

    .state('tab.writereport', {
      cache: false,
      url: '/writereport',
      views: {
        'tab-writereport': {
          templateUrl: 'templates/tab-write-report.html',
          controller: 'WriteReportCtrl as writeReportCtrl',
        }
      }
    })

    .state('tab.trail', {
      cache: false,
      url: '/trail',
      views: {
        'tab-writereport': {
          templateUrl: 'templates/write-report-trail.html',
          controller: 'ChooseTrailCtrl as trailCtrl',
        }
      }
    })

    .state('tab.status', {
      cache: false,
      url: '/status',
      views: {
        'tab-writereport': {
          templateUrl: 'templates/write-report-status.html',
          controller: 'ChooseStatusCtrl as statusCtrl',
        }
      }
    })

    .state('tab.condition', {
      cache: false,
      url: '/condition',
      views: {
        'tab-writereport': {
          templateUrl: 'templates/write-report-condition.html',
          controller: 'ChooseConditionCtrl as conditionCtrl',
        }
      }
    })

    .state('tab.work', {
      cache: false,
      url: '/work',
      views: {
        'tab-writereport': {
          templateUrl: 'templates/write-report-work.html',
          controller: 'WorkCtrl as workCtrl',
        }
      }
    })

    .state('tab.description', {
      cache: false,
      url: '/description',
      views: {
        'tab-writereport': {
          templateUrl: 'templates/write-report-description.html',
          controller: 'WriteDescriptionCtrl as writeCtrl',
        }
      }
    })


    .state('tab.account', {
      cache: false,
      url: '/account',
      views: {
        'tab-account': {
          templateUrl: 'templates/tab-account.html',
          controller: 'AccountCtrl as accountCtrl',
        }
      }
    })

    .state('tab.settings', {
      cache: false,
      url: '/settings',
      views: {
        'tab-settings': {
          templateUrl: 'templates/tab-settings.html',
          controller: 'SettingsCtrl as settingsCtrl',
        }
      }
    })

    .state('tab.report', {
      cache: false,
      url: '/report/:uuid',
      views: {
        'tab-reports': {
          templateUrl: 'templates/reports-view.html',
          controller: 'ViewReportCtrl as reportCtrl',
        }
      }
    })

    .state('tab.viewnearby', {
      cache: false,
      url: '/viewnearby',
      views: {
        'tab-viewnearby': {
          templateUrl: 'templates/tab-viewnearby.html',
          controller: 'ViewNearbyReportsCtrl as nearbyReportsCtrl',
        }
      }
    })

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/tab/writereport');

});

