angular.module('starter.directives')
  .directive('tfExpandHeightTo', function() {
    return function(scope, element, attrs) {
      window.addEventListener('native.keyboardhide', keyboardHideHandler);
      window.addEventListener('native.keyboardshow', keyboardShowHandler);

      scope.$on('$destroy', function() {
        window.removeEventListener('native.keyboardhide', keyboardHideHandler);
        window.removeEventListener('native.keyboardshow', keyboardShowHandler);
      });

      function keyboardShowHandler(e) {
        var keyboardHeight = e.keyboardHeight || e.detail.keyboardHeight;
        setHeight(keyboardHeight);
      }

      function keyboardHideHandler(e) {
        setHeight(0);
      }

      function setHeight(keyboardHeight) {
        setTimeout(function() {
          var elementHeight = element[0].parentNode.parentNode.clientHeight;

          element.css('height', elementHeight + "px");
        }, 100)
      }
    }
  })
