angular.module('starter.directives')
  .directive('tfPhotosChooser', ['PhoneCamera', '$ionicActionSheet', '$ionicModal', function(PhoneCamera, $ionicActionSheet, $ionicModal) {
    return {
      templateUrl: "templates/directives/photosChooser.html",
      restrict: 'E',
      scope: {
        photos: '=',
      },
      link: function($scope, $element, $attrs) {
        $scope.modalPicture = null;

        $ionicModal.fromTemplateUrl('templates/directives/photosChooser-modal.html', {
          scope: $scope,
          animation: 'fade-in'
        })
          .then(function(modal) {
            $scope.modal = modal;
          });

        $scope.getPicture = function() {
          $ionicActionSheet.show({
            buttons: [
              //{ text: 'Last Photo Taken' },
              { text: 'Take Photo' },
              { text: 'Choose from Library' },
            ],
            destructiveText: false,
            titleText: false,
            cancelText: 'Cancel',
            cancel: function() {
                  // add cancel code..
                },
            buttonClicked: function(index) {
              switch(index) {
                //case 0:
                //  break;
                case 0:
                  PhoneCamera.takePicture(success, error);
                  break;
                case 1:
                  PhoneCamera.choosePicture(success, error);
                  break;
              }

              function success(paths) {
                setTimeout(function() {
                  if (typeof paths == 'string') {
                    paths = [paths];
                  }
                  for (var i = 0; i < paths.length; i++) {
                    photoAdd(paths[i]);
                  }
                },0);
              }

              function error() {
                var args = arguments;
                setTimeout(function() {
                  photoError.apply(this, arguments);
                },0);
              }
              return true;
            }
          });
        }

        function photoError(path) {
          // do nothing for the time being
        }

        function photoAdd(path) {
          var photo = {path:path};
          $scope.photos.push(photo);
          $scope.$apply();
        }

        $scope.openModal = function(photo, $index) {
          $scope.modalPicture = {
            photo: photo,
            index: $index,
          };
          $scope.modal.show();
        };

        $scope.closeModal = function() {
          $scope.modal.hide();
        };

        $scope.$on('$destroy', function() {
          //$scope.modal.remove();
        });

        $scope.removePhoto = function(index) {
          $scope.photos.splice(index,1);
          $scope.closeModal();
        }
      },
    }
  }]);
