angular.module('starter.directives')
  .directive('tfSelectSheet', ['$ionicModal', function($ionicModal) {
    return {
      scope: {
        selectSheetOptions: '=',
        selectSheetModel: '=',
        selectSheetTitle: '@',
        selectSheetOptionsLabel: '@',
        selectSheetOptionsValue: '@',
      },
      restrict: 'A',
      link: function($scope, $element, $attrs) {

        $element.on('click', function() {
          $scope.options = [];

          for (var i = 0; i < $scope.selectSheetOptions.length; i++) {
            var row = $scope.selectSheetOptions[i];
            if (typeof row === 'string') {
              var opt = {
                label: row,
                value:  row,
              }
            }
            else {
              var opt = {
                label: row[$scope.selectSheetOptionsLabel || 'label'],
                value:  row[$scope.selectSheetOptionsValue || 'value'],
              }
            }
            $scope.options.push(opt);
          }

          var modal;
          var templateURL = 'templates/directives/select-sheet.html';
          var modalPromise = $ionicModal
            .fromTemplateUrl(templateURL, {
              scope: $scope,
              animation: 'fade-in'
            })
            .then(function(m) {
              modal = m;
              modal.show();
            });

          $scope.hideModal = function() {
            modal.hide();
            modal.remove();
          };
        });

        $scope.selectOption = function(value) {
          console.log(value);
          $scope.hideModal();
          $scope.selectSheetModel = value;
        }
      }
    };
  }]);
