angular.module('starter.directives')
  .directive('tfStepper', ['PhoneCamera', '$ionicActionSheet', '$ionicModal', function(PhoneCamera, $ionicActionSheet, $ionicModal) {
    return {
      templateUrl: "templates/directives/tfStepper.html",
      restrict: 'E',
      scope: {
        disabled: '=',
        ngModel: '=',
        hideDecrement: '=',
        hideIncrement: '=',
      },
      link: function($scope, $element, $attrs) {
        var initial = $scope.ngModel;

        checkSteppersDisabled();

        $scope.$watch(function() {
          return $scope.ngModel;
        }, function(after, before) {
          if (after !== '') {
            if (!isNumeric(after)) {
              $scope.ngModel = before === '' ? initial : before;
            }
            $scope.ngModel = Number($scope.ngModel);
          }
        })

        $scope.decrement = function() {
          $scope.ngModel = $attrs.min === undefined ? $scope.ngModel-1 : Math.max($attrs.min, $scope.ngModel-1);
          checkSteppersDisabled();
        };

        $scope.increment = function() {
          $scope.ngModel = $attrs.max === undefined ? $scope.ngModel+1 : Math.min($attrs.max, $scope.ngModel+1);
          checkSteppersDisabled();
        };

        function checkSteppersDisabled() {
          $scope.decrementDisabled = $attrs.min != undefined && $scope.ngModel <= $attrs.min;
          $scope.incrementDisabled = $attrs.max != undefined && $scope.ngModel >= $attrs.max;
        }

        function isNumeric(n) {
          return !isNaN(parseFloat(n)) && isFinite(n);
        }

      },
    }
  }]);
