angular.module('starter.services')
  .service('PBRMS', ['$http', '$q', 'PhoneLocalStorage', function($http, $q, PhoneLocalStorage) {
    var self = this;

    self.RMS_ENDPOINTS = {
      'production': {
        domain: 'http://www.pinkbike.com',
      },
      'radek': {
        domain: 'http://www.va2.pinkbike.com',
      },
      'trevor': {
        domain: 'http://www.va5.pinkbike.com',
      },
      'ben': {
        domain: 'http://www.va6.pinkbike.com',
      },
    };

    self.CURRENT_ENDPOINT_KEY = PhoneLocalStorage.get('endpoint', 'production');

    var REQUEST_TIMEOUT = 10000;
    var REQUEST_TIMEOUT = 5000;
    //var REQUEST_TIMEOUT = 1000;

    self.send = function(data) {
      var oData = {
        rmsP:'j2',
        rmsD:JSON.stringify(data),
      };

      var url = self.API_ENDPOINTS[self.CURRENT_ENDPOINT_KEY].domain+'/rms/';
      var request = {
        method: 'GET',
        url: url,
        params: oData,
        timeout: REQUEST_TIMEOUT
      };

      return $http(request)
        .then(function(response) {
          console.log('rms success');
          console.dir(response);
          if (data['rmsS']) {
            return response.data;
          }
          else {
            return $q.reject(response);
          }
        })
        .catch(function(err_response) {
          console.log('rms error');
          console.dir(err_response);

          var msg;

          if (err_response.status === 0) {
            msg = 'Could not reach server';
          }
          else if (err_response.status >= 500 && err_response.status < 600) {
            msg = 'Server Error';
          }
          // for any status reponse between 200 and 500 (so 2xx and 4xx responses),
          // look for an error message in the returned data
          else if (err_response.status >= 200 && err_response.status < 500) {
            if ('data' in err_response && 'rmsM' in err_response.data) {
              msg = err_response.data.rmsM;
            }
            else {
              msg = 'RMS Error';
            }
          }

          //console.log('Public API Error: '+msg);
          //console.log('request');
          //console.dir(request);
          //console.log('response');
          //console.dir(err_response);

          var err = new Error(msg);

          return TFErrorLogging.log('PBRMS.send', err, {request: request})
        })
        ;
    }

    self.setEndpoint = function(key) {
      self.CURRENT_ENDPOINT_KEY = key;
      PhoneLocalStorage.set('endpoint', self.CURRENT_ENDPOINT_KEY);
    }
  }])
