angular.module('starter.services')
  .service('PhoneCamera', function() {
    var self = this;

    self.debugFallback = function(success, error) {
      self.fakePhotoIndex = self.fakePhotoIndex || 11624211;
      self.fakePhotoIndex++;
      var fakePath = 'http://ep2.pinkbike.org/p2pb'+self.fakePhotoIndex+'/p2pb'+self.fakePhotoIndex+'.jpg'
      success(fakePath);
    }

    self.takePicture = function(success, error) {
      if (!navigator || !navigator.camera || !navigator.camera.getPicture) {
        return self.debugFallback(success, error);
      }

      var pictureOptions = {
        quality:            100,
        destinationType:    Camera.DestinationType.FILE_URI,
        correctOrientation: true,
        sourceType:         Camera.PictureSourceType.CAMERA,
        saveToPhotoAlbum:   true,
      };

      navigator.camera.getPicture(success, error, pictureOptions);
    }

    self.choosePicture = function(success, error) {
      if (!navigator || !navigator.camera || !navigator.camera.getPicture) {
        return self.debugFallback(success, error);
      }

      var pictureOptions = {
        quality:            100,
        destinationType:    Camera.DestinationType.FILE_URI,
        correctOrientation: true,
        sourceType:         Camera.PictureSourceType.PHOTOLIBRARY,
      };

      //navigator.camera.getPicture(success, error, pictureOptions);
      window.imagePicker.getPictures(success, error);
    }
  });
