angular.module('starter.services')
  .service('PhoneFileSystem', ['$q', function($q) {
    var self = this;

    self.copy = function(fromPath, toPath, name) {
      var deferred = $q.defer();

      // get from fileEntry
      window.resolveLocalFileSystemURL(fromPath, function(fileEntry) {
        // get to directory fileEntry
        window.resolveLocalFileSystemURL(toPath, function(dirEntry) {
          // move the file
          fileEntry.copyTo(dirEntry, name, function() {
            window.resolveLocalFileSystemURL(toPath+name, function(fileEntry) {
              deferred.resolve(fileEntry.toInternalURL());
            }, onErr);
          }, onErr);
        }, onErr);
      }, onErr);

      function onErr(err) {
        console.log('got error renaming');
        console.log(err.message);
        return deferred.reject(err);
      }

      return deferred.promise;
    }

    return this;
  }]);
