angular.module('starter.services')
  .service('PhoneGPS', ['$q', function($q) {
    var self = this;

    self.currentPosition = {};
    self.currentPositionTime = 0;

    self.getCurrentPosition = function(success, error) {
      var deferred = $q.defer();

      if (self.currentPosition.lat && self.currentPosition.lon) {
        setTimeout(function() {
          deferred.resolve(self.currentPosition);
        }, 0);
      }
      else {
        navigator.geolocation.getCurrentPosition(function(p) {
          if (typeof p.coords.latitude !== 'undefined') {
            self.currentPosition.lat = p.coords.latitude;
            self.currentPosition.lon = p.coords.longitude;
            self.currentPositionTime = new Date();
            deferred.resolve(self.currentPosition);
          }
          else {
            deferred.reject();
          }
        }, function(err) {
          if (err.code === 2) {
            deferred.reject('position unavailable.');
          }
          else {
            deferred.reject(err.message);
          }
        });
      }

      return deferred.promise;
    }
  }]);
