angular.module('starter.services')
  .service('PhoneKeyboard', [function($q) {
    var self = this;

    self.show = function($element) {
      try {
        console.log('showing keyboard');
        cordova.plugins.Keyboard.show();
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        cordova.plugins.Keyboard.disableScroll(true);
      }
      catch(err) {
        console.log('error closing keyboard');
        console.log(err.message);
      }

      if ($element) {
        $element.on('blur', autohide);

        function autohide() {
          self.hide();
          $element.off('blur', autohide);
        }
      }
    };

    self.hide = function() {
      try {
        console.log('closing keyboard');
        cordova.plugins.Keyboard.close();
      }
      catch(err) {
        console.log('error showing keyboard');
        console.log(err.message);
      }
    };

    self.focus = function($element) {
      setCaretPosition($element, $element[0].value.length);
      $element[0].focus();
      click($element);
      self.show($element);
    };

    function setCaretPosition($element, caretPos) {
      var elem = $element[0];
      if(elem != null) {
        if(elem.createTextRange) {
          var range = elem.createTextRange();
          range.move('character', caretPos);
          range.select();
        }
        else {
          if(typeof elem.selectionStart != 'undefined') {
            elem.setSelectionRange(caretPos, caretPos);
          }
        }
      }
    }

    function click($element) {
      var elem = $element[0];
      if(elem != null) {
        if (elem.dispatchEvent) {
          // Gecko-style approach (now the standard) takes more work
          var eventClass = 'MouseEvents';
          var event = document.createEvent(eventClass);

          event.initEvent('click', true, true);
          elem.dispatchEvent(event, true);
        }
        else if (elem.fireEvent) {
          // IE-old school style
          var event = document.createEventObject();
          elem.fireEvent('onclick', event);
        }
      }
    }
  }]);
