angular.module('starter.services')
  .service('PhoneLocalStorage', ['$window', function($window) {
    var self = this;

    //console.dir($window.localStorage);

    self.set = function(key, value) {
      $window.localStorage[key] = JSON.stringify(value);
    };

    self.get = function(key, defaultValue) {
      var val = $window.localStorage[key];

      if (val) {
        try {
          return JSON.parse(val);
        }
        catch(err) {
          console.log('could not parse value from local storage, returning default instead and removing');
          $window.localStorage.removeItem(key);
        }
      }

      return defaultValue;
    }

    self.remove = function(key) {
      $window.localStorage.removeItem(key);
    }
  }])
