angular.module('starter.services')
  .service('TFConditions', function() {
    var self = this;

    var conditions = {
      '0': {value: 0, order: 0, key: 'unknown',      text:'Unknown'},
      '1': {value: 1, order: 1, key: 'snow-packed',  text:'Snow Packed'},
      '7': {value: 7, order: 2, key: 'snow-covered', text:'Snow Covered'},
      '8': {value: 8, order: 3, key: 'freeze-thaw',  text:'Freeze/Thaw Cycle'},
      '2': {value: 2, order: 4, key: 'mud-snow',     text:'Prevalent Mud/Snow'},
      '3': {value: 3, order: 5, key: 'variable',     text:'Variable'},
      '4': {value: 4, order: 6, key: 'mostly-dry',   text:'Mostly Dry'},
      '5': {value: 5, order: 7, key: 'dry',          text:'Dry'},
      '6': {value: 6, order: 8, key: 'very-dry',     text:'Very Dry'},
    };

    self.initialCondition = conditions[5];

    self.all = function() {
      return conditions;
    };

    self.get = function(value) {
      return conditions[value];
    }
  }
  )
.filter('orderObjectBy', function() {
  return function(items, field, reverse) {
    var filtered = [];
    angular.forEach(items, function(item) {
      filtered.push(item);
    });
    filtered.sort(function (a, b) {
      return (a[field] > b[field] ? 1 : -1);
    });
    if(reverse) filtered.reverse();
    return filtered;
  };
});
