angular.module('starter.services')
  .service('TFCurrentReport', ['TFTrailsSearch', 'TFStatuses', 'TFConditions', 'TFReportsLocal', function(TFTrailsSearch, Statuses, TFConditions, TFReportsLocal) {
    var self = this;

    var queuedReports = [];
    var currentReport;

    self.initializeCurrentReport = function() {
      if (!currentReport) {
        currentReport = {};
      }
      currentReport.trail       = null;
      currentReport.status      = Statuses.initialStatus;
      currentReport.condition   = TFConditions.initialCondition;
      currentReport.description = '';
      currentReport.photos      = [];
      currentReport.work  = { worked: false, numPeople: 1, numHours: 0 };
    }

    self.saveCurrentReport = function() {
      return TFReportsLocal.addReport(currentReport).then(function() {
        self.initializeCurrentReport();
      });
    }

    self.getCurrentReport = function() {
      return currentReport;
    }

    self.initializeCurrentReport();

  }]);
