angular.module('starter.services')
  .service('TFReportsNearby', ['PhoneGPS', 'TFAPI', function(PhoneGPS, TFAPI) {
    var self = this;

    self.CURRENT_LOCATION = 'CURRENT_LOCATION';

    self.search = function(search) {
      var data = {
          'scope':'full',
          'filter':'active::1',
          'fields':'reportid,status,condition,description,created,trail',
          'sort':'created',
          'order':'desc',
          'rows':'30'
      };

      if (search.location != undefined) {
        var loc = search.location;
        if (loc === self.CURRENT_LOCATION) {
          return self.getLocationAndSearch(search);
        }
        else if (loc.lat && loc.lon) {
          data.filter += ';lat::'+loc.lat+';lon::'+loc.lon;
        }
      }

      if (search.range) {
        data.filter += ';nearby_range::'+search.range;
      }


      return TFAPI.publicAPI('reports', data);
    };

    self.getLocationAndSearch = function(search) {
      return PhoneGPS.getCurrentPosition()
        .then(function(coords) {
          // success
          search.location = {
            lat: coords.lat,
            lon: coords.lon,
          };

          // rerun search with the new details that include the current
          // location
          return self.search(search);
        });
    };

  }]);
