angular.module('starter.services')
  .service('TFTrailsSearch', ['PhoneGPS', 'TFAPI', function(PhoneGPS, TFAPI) {
    var self = this;

    self.CURRENT_LOCATION = 'CURRENT_LOCATION';

    self.search = function(search, skipCache) {
      var cache_key = 'trails-search';
      var data = {
          'scope':'basic',
          'filter':'',
          'fields':'trailid,title,status,condition,difficulty,latitude,longitude',
          'sort':'distance',
          'rows':'100'
      };

      if (search.location != undefined) {
        var loc = search.location;
        if (loc === self.CURRENT_LOCATION) {
          return self.getLocationAndSearch(search);
        }
        else if (loc.lat && loc.lon) {
          data.filter += ';lat::'+loc.lat+';lon::'+loc.lon;
        }
      }

      if (search.range) {
        data.filter += ';nearby_range::'+search.range;
      }

      if (search.text !== '') {
        cache_key += ';search::'+search.text;
        data.filter += ';search::'+search.text;
      }

      return TFAPI.publicAPI('trails', data, { cache: cache_key, readFromCache: !skipCache });
    };

    self.getLocationAndSearch = function(search) {
      return PhoneGPS.getCurrentPosition()
        .then(function(coords) {
          // success
          search.location = {
            lat: coords.lat,
            lon: coords.lon,
          };

          // rerun search with the new details that include the current
          // location
          return self.search(search);
        });
    };

  }]);
