angular.module('starter.services')
  .service('TFUploadLogging', ['$http', '$q', 'PhoneSQLite', function($http, $q, PhoneSQLite) {
    var self = this;

    var STATE_UPLOADED  = 1;
    var STATE_UPLOADING = 2;
    var STATE_ERROR     = 3;

    var DB_NAME = 'tf.db';
    var UPLOADS_TABLE_SCHEMA = 'CREATE TABLE uploads(uuid PRIMARY KEY, contenttype TEXT, contentuuid TEXT, startts, endts, state DEFAULT '+STATE_UPLOADING+', errmessage TEXT, erruuid TEXT);';

    self.startUpload = function(contenttype, contentuuid) {
      //console.log('startUpload');
      //console.log(contenttype);
      //console.log(contentuuid);

      var id = uuidgen.v1();
      var ts = +new Date;

      var query = 'INSERT INTO uploads (uuid, contenttype, contentuuid, startts) VALUES (?,?,?,?)';
      var params = [id, contenttype, contentuuid, ts];
      return PhoneSQLite.query(DB_NAME, query, params)
        .then(function(result) {
          return id;
        })
        ;
    }

    self.uploadSucceeded = function(uploadid) {
      //console.log('uploadSucceeded');
      //console.log(uploadid);

      var ts = +new Date;
      var query = 'UPDATE uploads SET state = ?, endts = ? WHERE uuid = ?';
      var params = [STATE_UPLOADED, ts, uploadid];
      return PhoneSQLite.query(DB_NAME, query, params);
    }

    self.uploadFailed = function(uploadid, errmessage, erruuid) {
      //console.log('uploadFailed');
      //console.log(uploadid);
      //console.log(errmessage);
      //console.log(erruuid);

      var ts = +new Date;
      var query = 'UPDATE uploads SET state = ?, endts = ?, errmessage = ?, erruuid = ? WHERE uuid = ?';
      var params = [STATE_ERROR, ts, errmessage, erruuid, uploadid];
      return PhoneSQLite.query(DB_NAME, query, params);
    }

    self.startUpload  = PhoneSQLite.createTableIfDoesNotExistWrapper(self.startUpload,  DB_NAME, 'uploads', UPLOADS_TABLE_SCHEMA);
  }]);
